Subject: bug#61525: closed (Re: bug#61525: 29.0.60; delete-frame will raise frames in another virtual desktop)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 26 Aug 2023 08:07:02 +0000

Your bug report

#61525: 29.0.60; delete-frame will raise frames in another virtual desktop

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
61525: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=61525
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#61525: 29.0.60; delete-frame will raise frames in another virtual desktop
From: Eli Zaretskii <[email-masked]>
To: Daniel Martín <[email-masked]>
Cc: [email-masked], [email-masked], [email-masked]
Date: Sat, 26 Aug 2023 11:06:21 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Daniel Martín <[email-masked]>
> Cc: Eli Zaretskii <[email-masked]>,  [email-masked],  [email-masked]
> Date: Sat, 19 Aug 2023 10:28:48 +0200
> 
> Po Lu <[email-masked]> writes:
> 
> > Daniel Martín <[email-masked]> writes:
> >
> >> * src/frame.h: Declare an NS-only function to make a frame the key
> >> window.
> >> * src/nsfns.m (ns_make_frame_key_window): Implement it.
> >> * src/frame.c (delete_frame): Call ns_make_frame_key_window instead of
> >> Fraise_frame.  (Bug#61525)
> >
> > This commit message extends into column 70.  Please fill it to 64
> > columns, or else the ChangeLog entries generated will be incorrectly
> > formatted.
> 
> I've attached a new patch with the commit message wrapped at 64 columns.

Thanks, installed on the master branch, and closing the bug.

Subject: 29.0.60; delete-frame will raise frames in another virtual desktop
From: Kai Ma <[email-masked]>
To: [email-masked]
Date: Wed, 15 Feb 2023 13:26:32 +0900
List-Id: <debbugs-submit.debbugs.gnu.org>

On MacOS, delete-frame can raise a frame in another virtual desktop,
which will cause switching between desktops.  This is annoying,
especially for emacsclient users.

To quote frame.c:

#ifdef NS_IMPL_COCOA
      else
	/* Under NS, there is no system mechanism for choosing a new
	   window to get focus -- it is left to application code.
	   So the portion of THIS application interfacing with NS
	   needs to know about it.  We call Fraise_frame, but the
	   purpose is really to transfer focus.  */
	Fraise_frame (frame1);
#endif

However, this has an undesired side effect: the desktop will be
switched.

Steps to reproduce:

1. Run emacs.
2. C-x 5 2, and move the new frame to another desktop.
3. C-x 5 0.  Now you see the desktop is switched.

This is a known issue for some time [1] and there is a patch that simply
disables raise_frame [2].  I'm not sure whether this patch is entirely
correct (and I think not).  But I do think the behavior should be
improved; at least the undesired desktop switching should be avoided.

Best regards,
Kai

[1] https://xenodium.com/no-emacs-frame-refocus-on-macos/
[2] https://github.com/d12frosted/homebrew-emacs-plus/blob/master/patches/emacs-28/no-frame-refocus-cocoa.patch